function [t,y] = strang(psi1,psi2,psi3,y0,tspan,N)
% Single step method based on Strang splitting
% psi1, psi2 and psi3 must be function of type @(h,y)
% y0: initial value
% tspan: [0,T]
% N: number of timesteps
% t: meshpoints of timegrid
% y: solution at meshpoints of timegrid

t = [tspan(1)];
y = [y0];
h = (tspan(2)-tspan(1))/N;

for k=1:N
  y0 = psi1(h/2,y0);
  y0 = psi2(h/2,y0);
  y0 = psi3(h,y0);
  y0 = psi2(h/2,y0);
  y0 = psi1(h/2,y0);
  y = [y;y0];
  t = [t;k*h];
end
