%Convergence study of extrapolated mid-point rule
function extraImplMprKonv

% AWP: y' = y, y(0) = 1;
% convergence study for local extrapolated rule
%f=@(y) -y;
y0=1;

% end point
T = 1;

%number of macro steps
N=2.^(1:4);

%sequence of number of micro-steps
n=1:3;

%compute the absolute error for each number of macro steps
err=zeros(size(N));
for i=1:length(N)
    err(i)=abs(exp(-T)-extraImplMpr(y0,T,N(i),n));
end

%loglog-plot
figure
loglog(N,err);

%find convergence rate
p=polyfit(log(N),log(err),1);
fprintf('convergence rate = %3.4f\n',p(1));